/* Interfaccia remota che definisce i metodi remoti per la gestione della
blackboard condivisa dagli agenti di uno stesso gruppo */

import java.rmi.*;
import java.lang.*;
import java.util.Vector;

public interface iBlackboard extends Remote {
    // modifica alla composizione del bunch
    Vector getIn( String name, String address, int port ) throws RemoteException;
    Vector tempLogin( String name, String address, int port ) throws RemoteException;
    String requestLogin( String name, String address, int port ) throws RemoteException; // fa una richiesta di login e blocca la blackboard.
    boolean getOut( String name ) throws RemoteException;
    // operazioni sul delta
    String read( boolean priority ) throws RemoteException;
    String read() throws RemoteException;
    boolean write( String value ) throws RemoteException;
    boolean isAvailable() throws RemoteException;
    boolean isAvailableForLogin() throws RemoteException;
    void unlock() throws RemoteException;
    void unlockLogin() throws RemoteException;
    // query sullo stato interno della blackboard
    int getPolicy() throws RemoteException;
    void confirmLogin( String name ) throws RemoteException;
    void rejectLogin( String name ) throws RemoteException;
}